diff --git a/licenses/gpl-howto.pt-br.po b/licenses/gpl-howto.pt-br.po
index 49837c9..4715518 100644
--- a/licenses/gpl-howto.pt-br.po
+++ b/licenses/gpl-howto.pt-br.po
@@ -1,14 +1,14 @@
-# Brazilian Portuguese translation of http://www.gnu.org/licenses/gpl-howto.html
-# Copyright (C) 2017 Free Software Foundation, Inc.
+# Brazilian Portuguese translation of https://www.gnu.org/licenses/gpl-howto.html
+# Copyright (C) 2018 Free Software Foundation, Inc.
 # This file is distributed under the same license as the original article.
 # Hélder M. Botter Ribas, 2001.
 # Jan 2015: GNUNify and trivially update a few strings (T. Godefroy).
-# Rafael Fontenelle <rafaelff@gnome.org>, 2016, 2017.
+# Rafael Fontenelle <rafaelff@gnome.org>, 2016-2018.
 msgid ""
 msgstr ""
 "Project-Id-Version: gpl-howto.html\n"
-"POT-Creation-Date: 2017-09-11 11:26+0000\n"
-"PO-Revision-Date: 2017-09-27 22:39-0300\n"
+"POT-Creation-Date: 2018-01-24 03:55+0000\n"
+"PO-Revision-Date: 2018-02-11 02:24-0200\n"
 "Last-Translator: Rafael Fontenelle <rafaelff@gnome.org>\n"
 "Language-Team: Brazilian Portuguese <www-pt-br-general@gnu.org>\n"
 "Language: pt_BR\n"
@@ -17,6 +17,7 @@ msgstr ""
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=2; plural=(n > 1);\n"
 "X-Generator: Virtaal 1.0.0-beta1\n"
+"X-Outdated-Since: 2018-01-24 03:55+0000\n"
 
 #. type: Content of: <title>
 msgid ""
@@ -78,11 +79,19 @@ msgstr ""
 
 #. type: Content of: <ul><li>
 msgid "Get a copyright disclaimer from your employer or school."
-msgstr "Obtenha um aviso de renúncia de copyright de seu empregador ou escola."
+msgstr ""
+"Obtenha um aviso de renúncia de direitos autorais de seu empregador ou "
+"escola."
 
 #. type: Content of: <ul><li>
-msgid "Give each file the proper copyright notices."
-msgstr "Dê a cada arquivo as notas de copyright apropriadas."
+msgid ""
+"Give each file the proper copyright notices. Make sure <a href=\"/licenses/"
+"identify-licenses-clearly.html\">to clearly identify which versions of the "
+"license users can use</a>."
+msgstr ""
+"Dê a cada arquivo os avisos de direitos autorais apropriados. Certifique-se "
+"de <a href=\"/licenses/identify-licenses-clearly.html\">identificar "
+"claramente quais versões da licenças os usuários podem usar</a>."
 
 #. type: Content of: <ul><li>
 msgid "Add a COPYING file with a copy of the GNU GPL or GNU AGPL."
@@ -97,15 +106,15 @@ msgstr ""
 
 #. type: Content of: <ul><li>
 msgid "Put a license notice in each file."
-msgstr "Coloque uma nota de licença em cada arquivo."
+msgstr "Coloque um aviso de licença em cada arquivo."
 
 #. type: Content of: <ul><li>
 msgid "(Optionally) make the program display a startup notice."
-msgstr "(Opcionalmente) faça o programa exibir uma nota de inicialização."
+msgstr "(Opcionalmente) faça o programa exibir um aviso de inicialização."
 
 #. type: Content of: <ul><li>
 msgid "(If using the AGPL) make the program offer copies of its source code."
-msgstr "(Se usar a AGPL) faça o programa oferecer cópias de seu código-fonte."
+msgstr "(Se usar a AGPL) faça o programa oferecer cópias de seu código fonte."
 
 #. type: Content of: <p>
 msgid ""
@@ -116,14 +125,16 @@ msgid ""
 "Affero GPL)."
 msgstr ""
 "Isso envolve a adição de dois elementos em cada arquivo fonte do seu "
-"programa: uma nota de copyright (como “<cite>Copyright 1999 Terry Jones</"
-"cite>”) e uma declaração de permissão de cópia, dizendo que o programa é "
-"distribuído sobre os termos da Licença Pública Geral GNU (ou da GPL Menor, "
-"ou da GPL Affero)."
+"programa: um aviso de direitos autorais (como “<cite>Copyright 1999 Terry "
+"Jones</cite>”) e uma declaração de permissão de cópia, dizendo que o "
+"programa é distribuído sobre os termos da Licença Pública Geral GNU (ou da "
+"GPL Menor, ou da GPL Affero)."
 
 #. type: Content of: <h3>
 msgid "The copyright disclaimer"
-msgstr "O aviso de renúncia de copyright (ou “copyright disclaimer”)"
+msgstr ""
+"O aviso de renúncia de direitos autorais<sup><a id=\"TransNote1-rev\" href="
+"\"#TransNote1\">1</a></sup>"
 
 #. type: Content of: <p>
 msgid ""
@@ -136,36 +147,37 @@ msgid ""
 msgstr ""
 "Para evitar possíveis complicações legais posteriores, é sábio pedir ao seu "
 "empregador ou escola, se for o caso, assinar um aviso de renúncia de "
-"copyright para seu programa, de forma a não ser possível posteriormente "
-"alegarem que o copyright lhes pertence e que você não tinha qualquer direito "
-"de lançar o programa. Isso realmente tem nada a ver com a GNU GPL &mdash; "
-"ela se aplica não importa qual licença de software livre você usa para "
-"lançar seu programa."
+"direitos autorais para seu programa, de forma a não ser possível "
+"posteriormente alegarem que o direito autoral lhes pertence e que você não "
+"tinha qualquer direito de lançar o programa. Isso realmente tem nada a ver "
+"com a GNU GPL &ndash; ela se aplica não importa qual licença de software "
+"livre você usa para lançar seu programa."
 
 #. type: Content of: <p>
 msgid ""
 "Here is a sample copyright disclaimer; just alter the names, title, and "
 "program description as appropriate:"
 msgstr ""
-"Aqui está um exemplo de aviso de renúncia de copyright; basta alterar os "
-"nomes, títulos e descrição do programa conforme apropriado:"
+"Aqui está um exemplo de aviso de renúncia de direitos autorais; basta "
+"alterar os nomes, títulos e descrição do programa conforme apropriado:"
 
 #. type: Content of: <blockquote><p>
 msgid ""
 "Yoyodyne, Inc., hereby disclaims all copyright interest in the program "
 "&ldquo;Woodpecker&rdquo; (which deconstructs trees)  written by James Hacker."
 msgstr ""
-"Yoyodyne, Inc., por meio deste renuncia todo e qualquer interesse no "
-"copyright do programa “Woodpecker” (que desconstrói árvores) escrito por "
-"James Hacker."
+"Yoyodyne, Inc., hereby disclaims all copyright interest in the program "
+"&ldquo;Woodpecker&rdquo; (which deconstructs trees)  written by James Hacker."
 
 #. type: Content of: <blockquote><p>
 msgid "<em>signature of Moe Ghoul</em> 1 April 1989"
-msgstr "<em>assinatura de Moe Ghoul</em>, 1º de Abril de 1989"
+msgstr "<em>signature of Moe Ghoul</em> 1 April 1989"
 
 #. type: Content of: <blockquote><p>
 msgid "Moe Ghoul, President of Vice"
-msgstr "Moe Ghoul, Presidente da Vice"
+msgstr ""
+"Moe Ghoul, Presidenf of Vice<sup><a id=\"TransNote2-rev\" href="
+"\"#TransNote2\">2</a></sup>"
 
 #. type: Content of: <p>
 msgid ""
@@ -179,8 +191,8 @@ msgstr ""
 "renúncia <a href=\"/philosophy/university.html\">em um estágio inicial da "
 "escrita do programa</a> para reduzir a resistência. Se você não é um "
 "assistente de pesquisa ou monitor, pode ser que a universidade tenha nenhum "
-"direito ao copyright de sua obra, mas consulte um advogado para ter certeza "
-"disso."
+"direito a reivindicar os direitos autorais sobre sua obra, mas consulte um "
+"advogado para ter certeza disso."
 
 #. type: Content of: <p>
 msgid ""
@@ -192,7 +204,9 @@ msgstr ""
 
 #. type: Content of: <h3>
 msgid "The copyright notice"
-msgstr "A nota de copyright"
+msgstr ""
+"O aviso de direitos autorais<sup><a id=\"TransNote3-rev\" href="
+"\"#TransNote3\">3</a></sup>"
 
 #. type: Content of: <p>
 msgid ""
@@ -203,12 +217,12 @@ msgid ""
 "were finished in 1998 and some were finished in 1999.  If several people "
 "helped write the code, use all their names."
 msgstr ""
-"A nota de copyright deve incluir o ano no qual você acabou de preparar a "
-"versão de lançamento (então, se você acabou em 1998 e não publicou até 1999, "
-"use 1998). Você deve adicionar o ano para cada lançamento anterior; por "
-"exemplo, se alguns lançamentos foram terminados em 1998 e outros em 1999 "
-"“Copyright 1998, 1999 Terry Jones”. Se várias pessoas ajudaram a escrever o "
-"código, inclua os nomes de todos elas."
+"O aviso de direitos autorais deve incluir o ano no qual você acabou de "
+"preparar a versão de lançamento (então, se você acabou em 1998 e não "
+"publicou até 1999, use 1998). Você deve adicionar o ano para cada lançamento "
+"anterior; por exemplo, se alguns lançamentos foram terminados em 1998 e "
+"outros em 1999 “Copyright 1998, 1999 Terry Jones”. Se várias pessoas "
+"ajudaram a escrever o código, inclua os nomes de todos elas."
 
 #. type: Content of: <p>
 msgid ""
@@ -237,13 +251,11 @@ msgid ""
 msgstr ""
 "Sempre use a palavra em inglês “Copyright”; por convenção internacional, ela "
 "é usada mundialmente, mesmo para materiais em outros idiomas. O símbolo de "
-"copyright “&copy;” pode ser incluído se você assim desejar (e seu conjunto "
-"de caracteres prover suporte para isso), mas não há necessidade. Não há "
-"significância legal em usar a sequência de três caracteres “(C)”, mas não há "
-"problema."
+"<i>copyright</i> “&copy;” pode ser incluído se você assim desejar (e seu "
+"conjunto de caracteres prover suporte para isso), mas não há necessidade. "
+"Não há significância legal em usar a sequência de três caracteres “(C)”, mas "
+"não há problema."
 
-# a frase naum ficou legal, ao traduzir "right near the top of each file", 
-# naum achei uma traducao melhor que esta.
 #. type: Content of: <p>
 msgid ""
 "If you have copied code from other programs covered by the same license, "
@@ -251,8 +263,9 @@ msgid ""
 "together, right near the top of the file."
 msgstr ""
 "Se você copiou o código de outros programas regidos pela mesma licença, "
-"copie as notas de copyright também. Coloque todos as notas de copyright para "
-"um arquivo juntos, no lado direito, perto do topo do arquivo."
+"copie os avisos de direitos autorais também. Coloque todos os avisos de "
+"direitos autorais para um arquivo juntos, no lado direito, perto do topo do "
+"arquivo."
 
 #. type: Content of: <h3>
 msgid "The license files"
@@ -299,7 +312,9 @@ msgstr ""
 
 #. type: Content of: <h3>
 msgid "The license notices"
-msgstr "As notas de licença"
+msgstr ""
+"Os avisos de licença<sup><a id=\"TransNote4-rev\" href=\"#TransNote4\">4</"
+"a></sup>"
 
 #. type: Content of: <p>
 msgid ""
@@ -307,10 +322,10 @@ msgid ""
 "should come right after its copyright notices.  For a one-file program, the "
 "statement (for the GPL) should look like this, to use GPL version 3 or later:"
 msgstr ""
-"A declaração da permissão de cópia de cada arquivo (também chamada de nota "
-"de licença, ou “license notices”) deve vir logo após as notas de copyright. "
-"Para um programa de somente um arquivo, a declaração (para a GPL) deve "
-"parecer com isso, para usar GPL versão 3 ou posterior:"
+"A declaração da permissão de cópia de cada arquivo (também chamada de aviso "
+"de licença) deve vir logo após os avisos de direitos autorais. Para um "
+"programa de somente um arquivo, a declaração (para a GPL) deve se parecer "
+"com isso, para usar GPL versão 3 ou posterior:"
 
 #. type: Content of: <pre>
 #, no-wrap
@@ -339,23 +354,7 @@ msgstr ""
 "    GNU General Public License for more details.\n"
 "\n"
 "    You should have received a copy of the GNU General Public License\n"
-"    along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.\n"
-"\n"
-"Tradução não oficial:\n"
-"\n"
-"    Este programa é um software livre; você pode redistribuí-lo e/ou \n"
-"    modificá-lo sob os termos da Licença Pública Geral GNU como publicada\n"
-"    pela Fundação do Software Livre (FSF); na versão 3 da Licença,\n"
-"    ou (a seu critério) qualquer versão posterior.\n"
-"\n"
-"    Este programa é distribuído na esperança de que possa ser útil, \n"
-"    mas SEM NENHUMA GARANTIA; sem uma garantia implícita de ADEQUAÇÃO\n"
-"    a qualquer MERCADO ou APLICAÇÃO EM PARTICULAR. Veja a\n"
-"    Licença Pública Geral GNU para mais detalhes.\n"
-"\n"
-"    Você deve ter recebido uma cópia da Licença Pública Geral GNU junto\n"
-"    com este programa. Se não, veja &lt;http://www.gnu.org/licenses/&gt;.\n"
-"\n"
+"    along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;<sup><a id=\"TransNote5-rev\" href=\"#TransNote5\">5</a></sup>.\n"
 
 #. type: Content of: <p>
 msgid ""
@@ -363,10 +362,10 @@ msgid ""
 "this program&rdquo; with the name of the program, and begin the statement "
 "with a line saying &ldquo;This file is part of NAME&rdquo;.  For instance,"
 msgstr ""
-"Para programas com mais de um arquivo, é melhor substituir o “this "
-"program” (“este programa”) pelo nome do programa, e começar a declaração com "
-"“This file is part of NAME” (“Este arquivo é parte do programa NOME”). Por "
-"exemplo,"
+"Para programas com mais de um arquivo, é melhor substituir o <i>“this "
+"program”</i> (“este programa”) pelo nome do programa, e começar a declaração "
+"com <i>“This file is part of NAME”</i> (“Este arquivo é parte do programa "
+"NOME”). Por exemplo,"
 
 #. type: Content of: <pre>
 #, no-wrap
@@ -399,25 +398,7 @@ msgstr ""
 "    GNU General Public License for more details.\n"
 "\n"
 "    You should have received a copy of the GNU General Public License\n"
-"    along with Foobar.  If not, see &lt;http://www.gnu.org/licenses/&gt;.\n"
-"\n"
-"Tradução não oficial:\n"
-"\n"
-"    Este arquivo é parte do programa Foobar\n"
-"\n"
-"    Foobar é um software livre; você pode redistribuí-lo e/ou \n"
-"    modificá-lo dentro dos termos da Licença Pública Geral GNU como \n"
-"    publicada pela Fundação do Software Livre (FSF); na versão 3 da \n"
-"    Licença, ou (a seu critério) qualquer versão posterior.\n"
-"\n"
-"    Este programa é distribuído na esperança de que possa ser  útil, \n"
-"    mas SEM NENHUMA GARANTIA; sem uma garantia implícita de ADEQUAÇÃO\n"
-"    a qualquer MERCADO ou APLICAÇÃO EM PARTICULAR. Veja a\n"
-"    Licença Pública Geral GNU para maiores detalhes.\n"
-"\n"
-"    Você deve ter recebido uma cópia da Licença Pública Geral GNU junto\n"
-"    com este programa, Se não, veja &lt;http://www.gnu.org/licenses/&gt;.\n"
-"\n"
+"    along with Foobar.  If not, see &lt;http://www.gnu.org/licenses/&gt;<sup><a id=\"TransNote6-rev\" href=\"#TransNote6\">6</a></sup>.\n"
 
 #. type: Content of: <p>
 msgid ""
@@ -437,15 +418,15 @@ msgid ""
 "When using the GNU AGPL, insert the word &ldquo;Affero&rdquo; before &ldquo;"
 "General&rdquo; in <em>all three</em> places."
 msgstr ""
-"Este documento deve ir no começo de cada arquivo fonte, perto das notas de "
-"copyright. Ao usar a GPL Menor, coloque a palavra “<cite>Lesser</cite>” "
-"antes de “<cite>General</cite>” em <em>todos os três</em> lugares. Ao usar a "
-"GNU AGPL, coloque a palavra “<cite>Affero</cite>” antes de “<cite>General</"
-"cite>” em <em>todos os três</em> lugares."
+"Este documento deve ir no começo de cada arquivo fonte, perto dos avisos de "
+"direitos autorais. Ao usar a GPL Menor, coloque a palavra “<cite>Lesser</"
+"cite>” antes de “<cite>General</cite>” em <em>todos os três</em> lugares. Ao "
+"usar a GNU AGPL, coloque a palavra “<cite>Affero</cite>” antes de "
+"“<cite>General</cite>” em <em>todos os três</em> lugares."
 
 #. type: Content of: <h3>
 msgid "Why license notices?"
-msgstr "Por que notas de licenças?"
+msgstr "Por que avisos de licenças?"
 
 #. type: Content of: <p>
 msgid ""
@@ -466,7 +447,7 @@ msgid ""
 "under license FOO,&rdquo; that leaves room for uncertainty about whether the "
 "license FOO applies to the code of that program."
 msgstr ""
-"Se um programa possui uma cópia de uma licença FOO pelos arquivos-fontes, "
+"Se um programa possui uma cópia de uma licença FOO pelos arquivos fontes, "
 "mas não tem uma declaração explícita de “Esse programa é lançado sob a "
 "licença FOO”, isso deixa espaço para incerteza sobre se a licença FOO se "
 "aplica ao código daquele programa."
@@ -484,13 +465,13 @@ msgstr ""
 "Se um lançamento possuir uma declaração de que “Esse programa é lançado sob "
 "a licença”, em um lugar central como o arquivo README, isso deixa a situação "
 "clara <em>para aquele lançamento</em>. Porém, programadores geralmente "
-"copiam os arquivos-fontes de um programa para o outro. Se um arquivo-fonte "
+"copiam os arquivos fontes de um programa para o outro. Se um arquivo fonte "
 "não contiver declaração sobre qual é sua licença, então mover para outro "
 "contexto elimina todo rastro daquele ponto. Isso convida confusão e erro."
 
 #. type: Content of: <h3>
 msgid "The startup notice"
-msgstr "A nota de inicialização"
+msgstr "O aviso de inicialização"
 
 #. type: Content of: <p>
 msgid ""
@@ -500,13 +481,13 @@ msgid ""
 "for more information about this."
 msgstr ""
 "Para programas interativos, é geralmente uma boa ideia fazer o programa "
-"exibir uma breve nota de copyright e de permissão de cópia quando ele "
-"começar. Veja <a href=\"/licenses/gpl-3.0.html#howto\">o final da GNU GPL</"
-"a> para mais informação sobre isso."
+"exibir um breve aviso de direitos autorais e de permissão de cópia quando "
+"ele começar. Veja <a href=\"/licenses/gpl-3.0.html#howto\">o final da GNU "
+"GPL</a> para mais informação sobre isso."
 
 #. type: Content of: <h3>
 msgid "The Affero notice"
-msgstr "A nota da Affero"
+msgstr "O aviso da Affero"
 
 #. type: Content of: <p>
 msgid ""
@@ -521,10 +502,10 @@ msgstr ""
 "Se você está relançando seu programa sob a GNU AGPL, e ele pode interagir "
 "com usuários pela rede, o programa deve oferecer seu fonte para aqueles "
 "usuários de alguma forma. Por exemplo, se seu programa é um aplicativo web, "
-"sua interface poderia exigir um link “<cite>Source</cite>” que leva os "
-"usuários para um pacote do código. A GNU AGPL é flexível o suficiente para "
-"permitir que você escolha um método que seja mais adequado para seu programa "
-"específico&mdash;veja seção 13 para detalhes."
+"sua interface poderia exigir um link <i>“Source”</i> que leva os usuários "
+"para um pacote do código. A GNU AGPL é flexível o suficiente para permitir "
+"que você escolha um método que seja mais adequado para seu programa "
+"específico veja &ndash; seção 13 para detalhes."
 
 #. type: Content of: <h3>
 msgid "Miscellaneous"
@@ -548,12 +529,13 @@ msgid ""
 "that puts you in a stronger position against anyone who violates the license "
 "in the US.  Most other countries have no system of copyright registration."
 msgstr ""
-"Não há requisitos legais para registrar o seu copyright em qualquer lugar; a "
-"simples escrita do programa o torna protegido por copyright. Contudo, nos "
-"EUA, é uma boa ideia registrar o copyright no Escritório de Registros de "
-"Copyrights dos EUA (<cite>US Copyright Office</cite>), o que coloca você em "
-"uma forte posição contra quem violar a sua licença nos EUA. A maioria dos "
-"países não possuem um sistema de registro de copyright."
+"Não há requisitos legais para registrar o seu direito autoral em qualquer "
+"lugar; a simples escrita do programa o torna protegido por direito autoral. "
+"Contudo, nos EUA, é uma boa ideia registrar o direito autoral no Escritório "
+"de Registros de Copyrights dos EUA (<cite>US Copyright Office</cite>), o que "
+"coloca você em uma forte posição contra quem violar a sua licença nos EUA. A "
+"maioria dos países não possuem um sistema de registro de direitos "
+"autorais<sup><a id=\"TransNote7-rev\" href=\"#TransNote7\">7</a></sup>."
 
 # Diretório dos Softwares Livres: rever a traducao disso.
 #. type: Content of: <p>
@@ -596,12 +578,95 @@ msgstr ""
 "um pacote GNU; de fato, esperamos que você o faça. Elas estão disponíveis "
 "para todo mundo. Se você gostaria de divulgar seu uso de uma licença "
 "específica, sinta-se à vontade para usar <a href=\"/graphics/license-logos."
-"html\" title=\"GNU License Logos\">uma de nossas logos</a>."
+"html\" title=\"Logos das Licenças GNU\">uma de nossas logos</a>."
 
 #. TRANSLATORS: Use space (SPC) as msgstr if you don't have notes.
 #. type: Content of: <div>
 msgid "*GNUN-SLOT: TRANSLATOR'S NOTES*"
-msgstr " "
+msgstr ""
+"<b>Notas do tradutor</b>:\n"
+"<ol>\n"
+"<li>\n"
+"<a id=\"TransNote1\" href=\"#TransNote1-rev\" class=\"nounderline\">&#8593;</"
+"a> \n"
+"Aviso de renúncia de direitos autorais no texto original, em inglês, é "
+"<i>copyright disclaimer</i>.\n"
+"</li>\n"
+"<li>\n"
+"<a id=\"TransNote2\" href=\"#TransNote2-rev\" class=\"nounderline\">&#8593;</"
+"a> \n"
+"Tradução não oficial:<br/>\n"
+"<br/>\n"
+"Yoyodyne, Inc., por meio deste renuncia todo e qualquer interesse nos   "
+"direitos autorais do programa “Woodpecker” (que desconstrói árvores)   "
+"escrito por James Hacker.<br/>\n"
+"<br/>\n"
+"<em>assinatura de Moe Ghoul</em>, 1º de Abril de 1989<br/>\n"
+"Moe Ghoul, Presidente da Vice<br/><br/>\n"
+"</li>\n"
+"<li>\n"
+"<a id=\"TransNote3\" href=\"#TransNote3-rev\" class=\"nounderline\">&#8593;</"
+"a> \n"
+"Aviso de direitos autorais no texto original, em inglês, é <i>copyright "
+"notice.</i>\n"
+"</li>\n"
+"<li>\n"
+"<a id=\"TransNote4\" href=\"#TransNote4-rev\" class=\"nounderline\">&#8593;</"
+"a> \n"
+"Aviso de licença no texto original, em inglês, é <i>license notice</i>.\n"
+"</li>\n"
+"<li>\n"
+"<a id=\"TransNote5\" href=\"#TransNote5-rev\" class=\"nounderline\">&#8593;</"
+"a> \n"
+"Tradução não oficial:<br/>\n"
+"<pre>\n"
+"Este programa é um software livre; você pode redistribuí-lo e/ou\n"
+"modificá-lo sob os termos da Licença Pública Geral GNU como publicada\n"
+"pela Free Software Foundation; na versão 3 da Licença, ou\n"
+"(a seu critério) qualquer versão posterior.\n"
+"\n"
+"Este programa é distribuído na esperança de que possa ser útil,\n"
+"mas SEM NENHUMA GARANTIA; sem uma garantia implícita de ADEQUAÇÃO\n"
+"a qualquer MERCADO ou APLICAÇÃO EM PARTICULAR. Veja a\n"
+"Licença Pública Geral GNU para mais detalhes.\n"
+"\n"
+"Você deve ter recebido uma cópia da Licença Pública Geral GNU junto\n"
+"com este programa. Se não, veja &lt;http://www.gnu.org/licenses/&gt;.\n"
+"</pre>\n"
+"</li>\n"
+"<li>\n"
+"<a id=\"TransNote6\" href=\"#TransNote6-rev\" class=\"nounderline\">&#8593;</"
+"a> \n"
+"Tradução não oficial:<br/>\n"
+"<pre>\n"
+"Este arquivo é parte do programa Foobar\n"
+"\n"
+"Foobar é um software livre; você pode redistribuí-lo e/ou\n"
+"modificá-lo dentro dos termos da Licença Pública Geral GNU como\n"
+"publicada pela Fundação do Software Livre (FSF); na versão 3 da\n"
+"Licença, ou (a seu critério) qualquer versão posterior.\n"
+"\n"
+"Este programa é distribuído na esperança de que possa ser útil,\n"
+"mas SEM NENHUMA GARANTIA; sem uma garantia implícita de ADEQUAÇÃO\n"
+"a qualquer MERCADO ou APLICAÇÃO EM PARTICULAR. Veja a\n"
+"Licença Pública Geral GNU para maiores detalhes.\n"
+"\n"
+"Você deve ter recebido uma cópia da Licença Pública Geral GNU junto\n"
+"com este programa, Se não, veja &lt;http://www.gnu.org/licenses/&gt;.\n"
+"</pre>\n"
+"</li>\n"
+"<li>\n"
+"<a id=\"TransNote7\" href=\"#TransNote7-rev\" class=\"nounderline\">&#8593;</"
+"a> \n"
+"No Brasil, o órgão no qual se pode fazer registro de direitos autorais "
+"depende do trabalho realizado. Para programas de computador, pode-se fazer "
+"no Instituto Nacional de Propriedade Industrial (INPI), em <a href=\"http://"
+"www.inpi.gov.br\">www.inpi.gov.br</a>. Para outros trabalhos, como livros, "
+"pode-se fazer na Biblioteca Nacional, por meio do serviço do Escritório de "
+"Direitos Autorais (EDA), em <a href=\"https://www.bn.gov.br\">www.bn.gov.br</"
+"a>.\n"
+"</li>\n"
+"</ol>"
 
 # type: Content of: <div><p>
 #. type: Content of: <div><div><p>
@@ -646,11 +711,11 @@ msgstr ""
 
 #. type: Content of: <div><p>
 msgid ""
-"Copyright &copy; 2001, 2007, 2008, 2009, 2013, 2014, 2017 Free Software "
-"Foundation, Inc."
+"Copyright &copy; 2001, 2007, 2008, 2009, 2013, 2014, 2017, 2018 Free "
+"Software Foundation, Inc."
 msgstr ""
-"Copyright &copy; 2001, 2007, 2008, 2009, 2013, 2014, 2017 Free Software "
-"Foundation, Inc."
+"Copyright &copy; 2001, 2007, 2008, 2009, 2013, 2014, 2017, 2018 Free "
+"Software Foundation, Inc."
 
 #. type: Content of: <div><p>
 msgid ""
@@ -669,13 +734,16 @@ msgstr ""
 "<b>Traduzido por</b>: Hélder M. Botter Ribas <a href=\"mailto:helder@grad."
 "icmc.sc.usp.br\">&lt;helder@grad.icmc.sc.usp.br&gt;</a>, 2001; Rafael "
 "Fontenelle <a href=\"mailto:rafaelff@gnome.org\">&lt;rafaelff@gnome.org&gt;</"
-"a>, 2017"
+"a>, 2017, 2018"
 
 # type: Content of: <div><p>
 #.  timestamp start 
 #. type: Content of: <div><p>
 msgid "Updated:"
-msgstr "Última atualização: "
+msgstr "Última atualização:"
+
+#~ msgid "Give each file the proper copyright notices."
+#~ msgstr "Dê a cada arquivo as notas de copyright apropriadas."
 
 #~ msgid ""
 #~ "It's wise to ask your employer or school, if any, to sign a copyright "